// WONDER WOMAN! from DC Comics.

/* CVARS - copy and paste to shconfig.cfg

//Wonder Woman
wonderwoman_level 0
wonderwoman_health 100		//Default 100
wonderwoman_armor 100		//Default 100
wonderwoman_cooldown 45		//How long between each time she can use it (def 45)
wonderwoman_searchtime 45	//How long time she seaches for a target (def 45)

*/

//WC3 Entangling Roots Ripoff :D

#include <amxmod>
#include <superheromod>

// GLOBAL VARIABLES
new gHeroName[]="Wonder Woman"
new bool:gHasWonWomanPowers[SH_MAXSLOTS+1]
new bool:stunned[SH_MAXSLOTS+1]
new bool:issearching[SH_MAXSLOTS+1]
new m_iTrail, iBeam4
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Wonder Woman", "1.0", "AssKicR")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("wonderwoman_level", "0")
	register_cvar("wonderwoman_cooldown", "45")
	register_cvar("wonderwoman_searchtime", "45")
	register_cvar("wonderwoman_health", "100")
	register_cvar("wonderwoman_armor", "100")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	shCreateHero(gHeroName, "Lasso", "Catch enemies with your lasso", true, "wonderwoman_level")

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// INIT
	register_srvcmd("wonderwoman_init", "wonderwoman_init")
	shRegHeroInit(gHeroName, "wonderwoman_init")

	// KEY DOWN
	register_srvcmd("wonderwoman_kd", "wonderwoman_kd")
	shRegKeyDown(gHeroName, "wonderwoman_kd")

	// EVENTS
	register_event("ResetHUD", "newSpawn","b")
	register_event("CurWeapon", "change_gun", "b", "1=1")

	// Let Server know about Wonder Woman's varibles
	shSetMaxHealth(gHeroName, "wonderwoman_health")
	shSetMaxArmor(gHeroName, "wonderwoman_armor")
}
//----------------------------------------------------------------------------------------------
public plugin_precache()
{
	iBeam4 = precache_model("sprites/zbeam4.spr")
	m_iTrail = precache_model("sprites/smoke.spr")
	precache_sound("turret/tu_ping.wav")
	precache_sound("weapons/cbar_hitbod3.wav")
	precache_sound("weapons/electro5.wav")
}
//----------------------------------------------------------------------------------------------
public wonderwoman_init()
{
	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	// 2nd Argument is 0 or 1 depending on whether the id has the hero
	read_argv(2,temp,5)
	new hasPowers = str_to_num(temp)

	if ( !hasPowers && gHasWonWomanPowers[id] && is_user_alive(id)){
		shRemHealthPower(id)
		shRemArmorPower(id)
	}

	gHasWonWomanPowers[id] = (hasPowers != 0)
}
//----------------------------------------------------------------------------------------------
public newSpawn(id)
{
	gPlayerUltimateUsed[id] =  false
}
//----------------------------------------------------------------------------------------------
public wonderwoman_kd()
{
	if ( !hasRoundStarted() ) return

	// First Argument is an id
	new temp[6]
	read_argv(1,temp,5)
	new id = str_to_num(temp)

	if ( !gHasWonWomanPowers[id] || !is_user_alive(id) ) return

	if ( issearching[id] || gPlayerUltimateUsed[id] ) {
		playSoundDenySelect(id)
		return
	}

	new parm[2]
	parm[0] = id
	parm[1] = get_cvar_num("wonderwoman_searchtime")
	searchtarget(parm)
}
//----------------------------------------------------------------------------------------------
public searchtarget(parm[2])
{
	new id = parm[0]
	
	if( !is_user_alive(id) ){
		issearching[id] = false
		return
	}
	
	new enemy, body
	get_user_aiming(id, enemy, body)

	if ( 0 < enemy <= 32 && !stunned[enemy] && get_user_team(id) != get_user_team(enemy) && is_user_alive(id) && is_user_alive(enemy) ) {

		issearching[id] = false
		gPlayerUltimateUsed[id] = true

		message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
		write_byte( 22 ); //TE_BEAMFOLLOW
		write_short(enemy);	// entity
		write_short(m_iTrail );	// model
		write_byte( 10 ); // life
		write_byte( 5 );  // width
		write_byte( 230 );	// r, g, b
		write_byte( 125 );	// r, g, b
		write_byte( 0 );	// r, g, b
		write_byte( 255 );	// brightness
		message_end();  // move PHS/PVS data sending into here (SEND_ALL, SEND_PVS, SEND_PHS)

		emit_sound(id,CHAN_ITEM, "weapons/cbar_hitbod3.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

		new waitparm[6]
		waitparm[0] = enemy
		waitparm[1] = 100
		waitparm[5] = floatround(get_user_maxspeed(enemy))
		set_user_maxspeed(enemy, 1.0)
		stunned[enemy] = true
		waitstop(waitparm)

		ultimateTimer(id, get_cvar_float("wonderwoman_cooldown"))
	}
	else {
		issearching[id] = true

		new counter = parm[1]
		while (counter >= 0) {
			counter -= 10
			if (counter == 0)
			emit_sound(id, CHAN_ITEM, "turret/tu_ping.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}

		--parm[1]
		if ( parm[1] > 0 && is_user_alive(id) )
		set_task(0.1, "searchtarget", 21, parm, 2)
		else
		issearching[id] = false
	}
}
//----------------------------------------------------------------------------------------------
// Entangle Roots (DOESN'T WORK ON BOTS)
public entangle(parm[2])
{
	new id = parm[0]
	new life = parm[1]
	new radius = 20
	new counter = 0
	new origin[3]
	new x1
	new y1
	new x2
	new y2

	get_user_origin(id, origin)

	emit_sound(id,CHAN_STATIC, "weapons/electro5.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)

	while (counter <= 7){
		if (counter == 0 || counter == 8)
			x1 = -radius
		else if (counter == 1 || counter == 7)
			x1 = -radius*100/141
		else if (counter == 2 || counter == 6)
			x1 = 0
		else if (counter == 3 || counter == 5)
			x1 = radius*100/141
		else if (counter == 4)
			x1 = radius

		if (counter <= 4)
			y1 = sqrt(radius*radius-x1*x1)
		else
			y1 = -sqrt(radius*radius-x1*x1)

		++counter
		if (counter == 0 || counter == 8)
			x2 = -radius
		else if (counter == 1 || counter == 7)
			x2 = -radius*100/141
		else if (counter == 2 || counter == 6)
			x2 = 0
		else if (counter == 3 || counter == 5)
			x2 = radius*100/141
		else if (counter == 4)
			x2 = radius

		if (counter <= 4)
			y2 = sqrt(radius*radius-x2*x2)
		else
			y2 = -sqrt(radius*radius-x2*x2)

		new height = 16+2*counter
		while (height > -40){

			message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
			write_byte( 0 )
			write_coord(origin[0]+x1)
			write_coord(origin[1]+y1)
			write_coord(origin[2]+height)
			write_coord(origin[0]+x2)
			write_coord(origin[1]+y2)
			write_coord(origin[2]+height+2)
			write_short(iBeam4)	// model
			write_byte( 0 ) // start frame
			write_byte( 0 ) // framerate
			write_byte( life ) // life
			write_byte( 10 )  // width
			write_byte( 5 )	// noise
			write_byte( 320 )	// r, g, b
			write_byte( 125 )	// r, g, b
			write_byte( 0 )	// r, g, b
			write_byte( 255 )	// brightness
			write_byte( 0 )		// speed
			message_end()

			height -= 16
		}

	}
}
//----------------------------------------------------------------------------------------------
public waitstop(parm[6])
{
	new id = parm[0]

	new origin[3]
	get_user_origin(id, origin)

	if (origin[0] == parm[2] && origin[1] == parm[3] && origin[2] == parm[4]) {
		new normalspeed = parm[5]
		new resetparm[2]
		resetparm[0] = id
		resetparm[1] = normalspeed
		set_task(float(parm[1]/10), "reset_maxspeed", 22, resetparm, 2)
		new entangleparm[2]
		entangleparm[0] = parm[0]
		entangleparm[1] = parm[1]
		entangle(entangleparm)
	}
	else {
		parm[2] = origin[0]
		parm[3] = origin[1]
		parm[4] = origin[2]
		set_task(0.1, "waitstop", 23, parm, 6)
	}
}
//----------------------------------------------------------------------------------------------
public reset_maxspeed(parm[])
{
	new enemy = parm[0]
	new normalspeed = parm[1]
	stunned[enemy] = false
	set_user_maxspeed(enemy, float(normalspeed))

}
//----------------------------------------------------------------------------------------------
public change_gun(id){

	if ( stunned[id] ) {
		set_user_maxspeed(id, 1.0)
	}
}
//----------------------------------------------------------------------------------------------